/************************************************************************************
 *																					*								
 *																					*
 * 							Slide - v2.0 - 2013-10-01								*
 *							 http://piwitheme.fr/									*
 *																					*
 *																					*
*************************************************************************************/
 
(function($) {
//_________________________________________________________________________________________________________________________________
//||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

	$(document).ready(function(){
		$('body').prepend($('<div />').attr({'class':'tab','id':'tab-0','data-urltab':window.location}).append($('<div />').attr('class','sld_tab'))).wrapInner($('<div />').attr({'class':'pageslide','id':'layer-0'}));
		$('.pageslide').first().show();
		var $w_w		= $(window).width(),
			$w_h		= $(window).height(),
			$tab		= 40,
			i			= 0,
			$layerShow	= $('#layer-0'),
			$slideshow	= [];
			
		$('body').append($('<div />').attr('id','slideLoading').css({top:(($w_h/2)-50),left:(($w_w/2)-50)}));
		$('body').data('layerShow',$layerShow);
		_init_page()
            	
		$(document).on('click','.slide', function(e) {
			var $url 	= $(this).attr('href');
			
			$int 		= setTimeout(function() {
				$('#slideLoading').css('z-index',1000)
				}, 500);
			i++;
			
			_load($url);
			_pushstate($url);	
			
			e.preventDefault();
		});

		$(document).on('click','.sameLayer', function(e) {
			var $href 		= $(this).attr('href'),
				$layerShow 	= $('body').data('layerShow'),
				$url 		= $href + ' #the_page',
				$slide_w	= $layerShow.width();
				
			_pushstate($href);
			
			if ($('.slshFirst').length){
				$urlFirst 	= $('.slshFirst').attr('href')
			} else {
				$urlFirst 	= $href 
			};
			
			$('#the_page',$layerShow).addClass('unwrap').load($url, function(){
				_init_page($urlFirst,$slide_w)
				$('.unwrap').children().unwrap();
			});	
			
			e.preventDefault();
		});	
		
		$(document).on('click','.tab', function(e) {
			_close( $(this) );
			var $url = $(this).data('urltab');
			_pushstate($url);				
		});
		
		$(document).on('submit','#quicksearch', function(e) {
			i++;
			var $val	= $('#qsearchInput').attr('value'),
				$url	= 'qsearch.php?q='+ $val,
				frame 	= $("<iframe />").attr({src: $url,id: 'frame'}).css({display:'none'});
				
				$('body').append(frame);
				
				setTimeout(	function () {
					var $obj = $("#frame").contents(),
						$urlframe = $obj[0].location.href;
					$('#frame').pushstate($urlframe);
					$('#frame').remove()
					},
				1000);
				
			_load($url);
			$(this).attr('value', qsearch_prompt);
			
			e.preventDefault();
		});

// Picture page rating
		$(document).on('mouseover','.rateButton',function(){
			$('#rateForm input').each(function(){
				$(this).removeClass('rateButtonFull').removeClass('rateButtonSelected');
				});
			$(this).addClass('rateButtonFull');
			var rate	= $(this).attr('title'),
				nth		= ':nth-child(-n+' + rate + ')';
			$('.rateButton' + nth).addClass('rateButtonFull');
		});
				
		$(document).on('mouseout','#rateForm',function(){
			$('#rateForm input').each(function(){
				$(this).removeClass('rateButtonFull').addClass('rateButton');
			});
			$('#rateForm input[type="button"]').addClass('rateButtonSelected');
			_rate_star()
		});
				
		$(document).on('click','.rateButton', function(e){
			var form 	= $(this).parents('form'),
				hrefa 	= form.attr('action'),
				hrefm 	= form.attr('method'),
				rate 	= $(this).attr('title'),
				rate	= 'rate=' + rate;
			$.ajax({
				url		: hrefa,
				type	: hrefm,
				data	: rate,
				success	: function(){
					hrefa = hrefa.substring(0,hrefa.indexOf('&'));
					hrefInf = hrefa + ' #imageInfos';
					$('#imageInfos').addClass('unwrap').load(hrefInf,function(){
						_rate_star();
						_imageInfo();
						$('.unwrap').children().unwrap();
					});
				}
			});
			e.preventDefault();
		});
		
//switchbox derivative
		$(document).on('click','.derivative', function(){
			var url			= $(this).data('url'),
				typeSave	= $(this).data('typesave'),
				typeMap 	= $(this).data('typemap'),
				cookies		= $(this).data('cookie')
				theImg		= $('#theMainImage');
			theImg.attr({'width':'' ,'height':'', 'src': url , 'useMap': '#map' + typeMap});
			$('#derivativeSwitchBox .switchCheck').css('visibility','hidden');
			$('#derivativeChecked' + typeSave).css('visibility','visible');
			document.cookie = 'picture_deriv='+typeSave+';path=cookies';
		});		
		
		$(document).on('click','.original',function(){
			var theURL		= $(this).data('url'),
				winName		= $(this).data('winname'),
				features	= $(this).data('features');
			$.getScript('./themes/default/js/scripts.js', function(){
				phpWGOpenWindow(theURL,winName,features)
			});
		});
		
		$(document).on('click','.privacy', function(){
			var rootUrl		= $(this).data('root'),
				id			= $(this).data('id'),
				level		= $(this).data('level');
			setPrivacyLevel(rootUrl, id, level);
		});

//add comment
		$(document).on('click', '#addComment input[type=submit]', function(e){
			$(this).valid_comment();
			e.preventDefault();
		});
		$(document).on('click', '#editComment input[type=submit]',  function(e){
			$(this).valid_comment();
			e.preventDefault(); 
		});

// removal/edit comment
		$(document).on('click', '.actions a', function(e){
			var $a		= $(this);
			if($a.hasClass('delet')){
				var	$confi 	= $a.attr('confirm');
				if (confirm($confi)) {
					_rem_ed($a);
				};
			}
			_rem_ed($a);
			e.preventDefault();
		});
		
//Change the order of comments
		$(document).on('click', '.commentsOrder', function(e){
			var $a		= $(this);
			_rem_ed($a);
			e.preventDefault();
		});

//edit profil		
		$(document).on('click', '#profile input[name=reset_to_default]', function(e){
			var $profil	 	= $('#profile'),
				$profilhref	= $profil.attr('action'),
				$profilmet	= $profil.attr('method'),
				$profilser	= $profil.serialize(),
				$profilval	= $(this).attr('value'),
				$profilnam	= $(this).attr('name'),
				$data = $profilser + '&' + $profilnam + '=' + $profilval;
				$.ajax({           
					url		: $profilhref, 
					type	: $profilmet, 
					data	: $data, 
					success	: function(html) {
						var $content = $(html).find('#profile');
						$profil.replaceWith($content)
					}
				});			
			e.preventDefault();
		});

// search page
		$(document).on('submit', '.theSearchPage .filter', function(e){
			var $sch 		= $('.filter'),
				$schmet 	= $sch.attr('method'),
				$schser		= $sch.serialize(),
				$schhref	= $sch.attr('action');
				$schser 	= $schser+"&submit=Valide";
			$.ajax({           
				url		: $schhref, 
				type	: $schmet, 
				data	: $schser, 
				success	: function(html){
					var $e = $(html).find('.errors');
					if($e.leng$th){
						var $inf = $e.text();
						_message($inf);
					} else {
						var $href 		= $(html).find('.titrePage h2 a:nth-child(2)').attr('href'),
							$layerShow 	= $('body').data('layerShow'),
							$url 		= $href + ' #the_page';
						$('#the_page', $layerShow).addClass('unwrap').load($url,function(){
							_init_page();
							$('.unwrap').children().unwrap();
						});
					};	
				}
			});
			e.preventDefault();
		});
				
//comment page
		$(document).on('submit', '.theCommentsPage .filter',  function(e){
			var $com 		= $('.filter'),
				$commet 	= $com.attr('method'),
				$comser		= $com.serialize(), 
				$comhref 	= $com.attr('action');
			$.ajax({           
				url		: $comhref, 
				type	: $commet, 
				data	: $comser, 
				success	: function(html){
					var $layerShow 		= $('body').data('layerShow'),
						$comfilt		= $(html).find('#content');
					$('#content', $layerShow).replaceWith($comfilt);	
				}
			});
			e.preventDefault();
		});
		
//switchBox 
		var $optbox = [	{li : '#sortOrderLink', box : '#sortOrderBox'},
						{li : '#derivativeSwitchLink' , box : '#derivativeSwitchBox'},
						{li : '#privacyLevelLink' , box : '#privacyLevelBox'},
						{li : '#calendarViewSwitchLink' , box : '#calendarViewSwitchBox'}
						];
		$.each($optbox, function(i, a){
			$(document).on('click', a.li , function(e) {
				var $layerShow 	= $('body').data('layerShow'),
					$ele		= $( a.box  , $layerShow),
					ePos 		= $(this).position(),
					ePos_h		= $(this).height();
				if ($ele.is(":hidden")){
					var left	= (ePos.left) + 'px',
						top		= (ePos.top + ePos_h) + 'px';
					$ele.css({left: left , top: top }).show();
				}
			e.preventDefault();	
			});
			$(document).on('mouseleave', a.box, function() {
				$(this).hide();
			});
		});
		
//_____function SLIDE______________________________________________________________________________________________________________________________________________
		function _init_page($urlFirst,$slide_w) {
		var $layerShow 	= $('body').data('layerShow');
			_selectPageSlide();
			_display_menu();
			_titre_page();
			_scrollbar();
			_content_size();
			_piwitheme_link();
			_dragbar_tabs();
			if($('#the_page',$layerShow).hasClass('thePicturePage')){
				_rate_star();
				_imageInfo()
			};
			if($('#the_page',$layerShow).hasClass('EC_drag')||$('#the_page',$layerShow).hasClass('EC_tictac')){
				_ECaptcha();
			};
			if($('#slideshow').length){
				$('#theHeader', $layerShow).remove();
				_load_slideshow($urlFirst, $slide_w);
				
			};
			if($('body').hasClass('lightbox')||$('body').hasClass('lightboxReady')) {
				_lightbox()				
			};
			if($('body').hasClass('GThumb')||$('body').hasClass('GThumbReady')) {
				_GThumb()
			};
			if($('body').hasClass('MyPiwiShop')||$('body').hasClass('MyPiwiShopReady')) {
				_MyPiwiShop()
			};

		};		
		
		function _load( $url ) {
			var	$z 				= (100 / i).toFixed(),
				$tab 			= 40 * i,
				$pageslide_w 	= $w_w - $tab,
				$href 			= $url + ' #the_page';
				
			$('body').append($('<div />').attr('class','pageslide').css({ left: 'auto', right: '-' + $w_w + 'px' }));
			$('.pageslide').attr('id', function(i){
				return "layer-" + i;
			});
			
			var $layerPrev		= $('#layer-' + (i - 1)),
				$layerShow		= $('#layer-' + i);

			$layerShow.css({'z-index'	: $z,
							width		: $pageslide_w +'px'
			})	
			$('body').data('layerShow',$layerShow);
			$('body').data('layerPrev',$layerPrev);
			$('body').data( 'i',i);
			$layerShow.load( $href, function(){
				$layerPrev	.css({right:'auto'})
							.animate({marginLeft: - $pageslide_w + ((i - 1) * 40)}, 1000);
				$layerShow	.show()
							.animate({right: 0}, 1000)
							.prepend($('<div />')
							.attr({'class':'tab','id':'tab-0','data-urltab':window.location})
							.append($('<div />').attr('class','sld_tab')));
				$('.tab').attr('id', function(i){
					return "tab-" + i;
				});
				$('#slideLoading').css('z-index',0);
				clearTimeout($int);
				_init_page($url, $pageslide_w)
			});
		};

		function _selectPageSlide(){
			var $layerShow 	= $('body').data('layerShow'),
				$a 			= [	'#menu_start a',
								'.navigationBar a',
								'.calendarBar a',
								'.calendarCalBar a',
								'.navigationButtons a',
								'#imageHeaderBar a',
								'.calImg a',
								'.date_today',
								'#sortOrderLink',
								'#sortOrderBox a',
								'#derivativeSwitchBox a',
								'#derivativeSwitchLink',
								'.actionButtons a',
								'.actions a',
								'.navThumb',
								'.calendarTitle a',
								'#linkToPiwigo a',
								'#copyright a',
								'#languageSwitchLink',
								'#languageSwitchBox a',
								'#theHeader a',
								'#myHomePage a',
								'#mbAdditionalPages a',
								'#photosAddContent a',
								'.amm-MenuBar-links-icons a',
								'.commentsOrder',
								'#calendarViewSwitchLink',
								'#calendarViewSwitchBox a',
								'#ato_header a',
								'#ato_header_closed a',
								'a[rel=colorbox0]'
								],
				$b 			= [	'.pwg-icon-letters',
								'.pwg-icon-cloud',
								'.pwg-icon-help',
								'.pwg-icon-calendar',
								'.pwg-icon-camera-calendar',
								'.pwg-icon-favorite-del',
								'.pwg-icon-caddie-add',
								'.pwg-icon-category-view-flat',
								'.pwg-icon-category-view-normal',
								'#thePicturePage .pwg-icon-slideshow',
								'#thePicturePage .pwg-icon-camera-info',
								'#thePicturePage .pwg-icon-save',
								'#thePicturePage .pwg-icon-favorite-add',
								'#thePicturePage .pwg-icon-representative',
								'#thePicturePage .pwg-icon-edit',
								'.pwg-icon-category-edit'
								],
				$c 			= [	'.description_stuffs .zero nb-comments',
								'.description_stuffs .nb-hits',
								'.description_stuffs .nb-comments'
								],
				$d			= [ '.pwg-icon-arrow-n'
								],
				$e 			= [	'#linkToPiwigo a',
								'#copyright a'
								],
				$f			= [ '.navigationButtons a',
								'.navThumbs a',
								'.navigationBar a',
								'#derivativeSwitchBox a',
								'#sortOrderBox a',
								'#theMainImage map area a',
								'#calendarViewSwitchBox a',
								'.calImg a',
								];
				$g			= [ '.pwg-icon-caddie-add',
								'.pwg-icon-category-view-normal',
								'.pwg-icon-calendar',
								'.pwg-icon-camera-calendar'
								];
								
			if($('body').hasClass('withlightbox')) {	
					$a.push('.illustration a');
				};
					
			$.each($a, function(i,e) {
				$(e, $layerShow).addClass('noSlide')
			});
			$.each($b, function(i,e) {
				$(e, $layerShow).parent().addClass('noSlide')
			});
			$.each($c,function(i,e) {
				$(e, $layerShow).remove()
			});
			$.each($d,function(i,e) {
				$(e, $layerShow).parent().remove()
			});
			$.each($e,function(i,e) {
				$(e, $layerShow).attr('target','blank')
			});
			$.each($f, function(i,e) {
				$(e, $layerShow).addClass('sameLayer')
			});
			$.each($g, function(i,e) {
				$(e, $layerShow).parent().addClass('sameLayer')
			});

			$('a:not(.noSlide)', $layerShow).addClass('slide');
			$('#layer-0 ').find('.sameLayer').removeClass('sameLayer');

			$('.stuffs_block .illustration .description', $layerShow).removeClass('description').addClass('description_stuffs');
			$('.titrePage + div', $layerShow).addClass('blockConteneur');
			$('.myHomePage_links a[href="index.php?/contact"]', $layerShow).addClass('slide');
		};
		
		function _titre_page() {
			var $layerShow 	= $('body').data('layerShow'),
				$titre 		= $('#content .titrePage h2',$layerShow).first().text(),
				$titre		= $titre.substring($titre.lastIndexOf("/")).replace("/","");
			$('#content .titrePage h2',$layerShow).first().replaceWith("<h2>"+ $titre +"</h2>");
			
			if (($titre.indexOf("[")>=0)) {
				var $titreTab	= $titre.substring(0,$titre.indexOf("[",1));
			}else{
				var $titreTab 	= $titre;
			};
			$('.sld_tab',$layerShow).text($titreTab);
		
			$('.browsePath a',$layerShow).remove();
			var $titre		= $('.browsePath',$layerShow).text(),
				$titre		= $titre.substring($titre.lastIndexOf("/")).replace("/","").replace("[","").replace("]","");
			$('.browsePath',$layerShow).replaceWith("<h2>"+ $titre +"</h2>");
		};
		
		function _scrollbar() {
			var $layerShow 	= $('body').data('layerShow'),
				$settings 	= {	verticalDragMinHeight: 100,
								verticalDragMaxHeight: 100,
								autoReinitialise: true
							};
			var $pane 		= $('.scrollpane', $layerShow).jScrollPane($settings);
		};
		
		function _display_menu() {
			var $layerShow 	= $('body').data('layerShow');
			if($layerShow.attr('id') != ('layer-0')) { 
				$layerShow.find('#menubar').remove();
				$layerShow.find('#theHeader').addClass('headbord')
			};
			$('#theIdentificationPage #menu').remove();
		};
		
		function _content_size(){
			var $layerShow 	= $('body').data('layerShow'),
				$headerH	= $('#theHeader', $layerShow).height(),
				$headerBar	= $('.imageHeaderBar', $layerShow).height(),	
				$copyright	= $('#copyright', $layerShow).height(),
				$imageToolBar = $('.imageToolBar', $layerShow).height()
				$w_mh 		= $(window).height() - ($headerH + $headerBar + $copyright +$imageToolBar + 50 ) + 'px';
			$('#content',$layerShow).css({minHeight: $w_mh});
		};

		function _piwitheme_link(){
			var $layerShow 	= $('body').data('layerShow');
			var $link		= ' - theme by <a href="http://piwitheme.fr" target="_blank">piwitheme</a>';
			$('#copyright', $layerShow).append($link);
		};

		function _rate_star(){
			$('.rateButton').attr('value','');
			if ($('.rateButton [type="button"]').length){
				var rate	= $('.rateButtonSelected').attr('title'),
					nth		= ':nth-child(-n+' + rate + ')';
				$('.rateButton' + nth).addClass('rateButtonFull');
			}
		}
		
		function _imageInfo() {
			$('.imageInfo a').each(function(){
				var text = $(this).text();
				$(this).wrap($('<span />').html(text)).remove();
			})
		};
		
		function _load_slideshow($href,$slideW) {
			$('#slideshow').empty().addClass('slideloader');
			if (!$('#slideshow').hasClass('slideshowReady')) {
				$.getScript('themes/Slide/js/slideshow.js', function(){
					$('#slideshow').addClass('slideshowReady');
				});
			};
			
			$.ajax({
				url 	: $href,
				success : function(html){
					var $next	= $(html).find('.pwg-button-icon-right').attr('href'),
						$title	= $(html).find('#imageHeaderBar h2').text(),
						$img	= $(html).find('#theImage #imgContent').data('src'),
						$img_h	= $(html).find('#theImage #imgContent').data('height'),
						$img_w	= $(html).find('#theImage #imgContent').data('width');
						
					_stock_img($img,$title,$img_h,$img_w);
					if(typeof $next != "undefined"){
						_load_slideshow($next,$slideW)
					}else{
						$('#slideshow').removeClass('slideloader').slideshow({
							imgs				: $slideshow,
							autoPlay			: true,
							speed				: 3000,
							height				: $w_h,
							width				: $slideW - 40,
							navType				: 'thumb',
							styleSlideshow		: 'Fade',
							thumb_always		: false,
							thumb_width			: 100,
							thumb_height		: 80,
						})
					};
				}	
			})
		};

		function _stock_img($href,$title,$height,$width){
			var $img = {src : $href  , title : $title , descr : $title , height : $height , width : $width};
		console.debug($img);
			$slideshow.push($img);
		};
		
		function _tabs_dragbar() {
			var $layerShow 	= $('body').data('layerShow');
			$('.tab',$layerShow).fadeOut(1000).css("cursor","default");
			$('.jspDrag',$layerShow).css("cursor","pointer");			
			$('.jspVerticalBar',$layerShow).fadeIn(1000)
		};
		
		function _dragbar_tabs() {
			var $layerPrev 	= $('body').data('layerPrev');
			if (typeof ($layerPrev) != 'undefined') {
				$('.tab',$layerPrev).fadeIn(1000).css("cursor","pointer");
				$('.jspDrag',$layerPrev).css("cursor","default");			
				$('.jspVerticalBar',$layerPrev).fadeOut(1000)
			}
		};
		
		function _close($tabClick) {
			var $layerBack	= $tabClick.parent(),
				$layerShow 	= $('body').data('layerShow'),
				$newI		= $layerBack.attr('id'),
				$newI		= $newI.substring($newI.lastIndexOf("-")).replace("-","");

			$('body').data('layerShow', $layerBack);
			_tabs_dragbar();
			$layerShow.animate({left: $w_w}, 1000,function(){
				if($('#slideshow').length){
					var $inter 		= $('#slideshow').data('e').interval;
					$slideshow		= [];
					clearTimeout($inter);
				};
				$layerBack.nextAll('.pageslide').remove();
				var $layerPrev = $layerBack.prev
			});
			$layerBack.css({right:'auto'}).animate({marginLeft:($newI * 40)}, 1000);
			i 			= $newI;
			var 	$layerPrev	= $('#layer-' + (i - 1));
			$('body').data( 'i',i);		
			$('body').data('layerPrev', $layerPrev)
		};
		
		function _pushstate($url) {
			window.top.history.pushState({ key: i }, 'titre', $url)
			window.onpopstate = function(e){
				if (!e.state || e.state.key < i) {
					$layerPrev = $('body').data('layerPrev');
					_close($('.tab',$layerPrev))
				} else {
					i++;
					var $url = window.location;
					_load($url);	
				}
			}
		};
		
		function setPrivacyLevel(rootUrl, id, level) {
			var y = new PwgWS(rootUrl);
			y.callService(
				"pwg.images.setPrivacyLevel", {image_id: id, level:level} ,
			{
				method: "POST",
				onFailure: function(num, text) { alert(num + " " + text); },
				onSuccess: function(result) {
					  $('#privacyLevelBox .switchCheck').hide();
					  $('#levelCheck'+level).show();
				}
			});
		};

		function _rem_ed(e) {
			var $href = e.attr('href');
			$.ajax({  
				url		: $href, 
				success	: function(html){
				_comment_reload(html)
				}
			});
		};	
				
		$.fn.valid_comment = function(){	
			var addcom 	= $(this).parents('form'),
				formp 	= addcom.children('p'),
				contid 	= $('#contentid'),
				contval = contid.val(),
				contlen = contid.length,
				aut		= $('#author'),
				autval	= aut.val(),
				autlen	= aut.length,
				em		= $('#email'),
				emval	= em.val(),
				emlen 	= em.length,
				emregl	= /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/,
				href 	= addcom.attr('action'),
				framehref= href;
			formp.children().each(function(){
				$(this).removeClass('requi');
			});
			$.ajax({           
				url		: href, 
				type	: addcom.attr('method'), 
				data	: addcom.serialize(),
				error	: function (xhr, ajaxOptions, thrownError) {
					var e	 	= (xhr.responseText),
						e 		= e.substring(e.indexOf('<div class="errors">')),
						e 		= e.substring(e.indexOf('<li>') , e.indexOf('</ul>')),
						reg 	= new RegExp("(<li>)","g"),
						rege 	= new RegExp("(</li>)","g"),
						inf		= e.substring(e.indexOf('<li>'),e.lastIndexOf('</li>')).replace(reg,'').replace(rege,'');
					_message(inf);
				},
				success	: function(html){
					var inf 	= $(html).find('.infos li').text();
					if(href.indexOf('&')>=0){href = href.substring(0,href.indexOf('&'))}
					_message(inf);
					_comment_reload(html);
				}			
			});
		};
		
		function _comment_reload(html){
			var $com 		= $(html).find('#comments'),
				$layerShow 	= $('body').data('layerShow');
			$('#comments', $layerShow).replaceWith($com);
		};

		function _message(inf) {
			if($('#msgBox').length==0){
				$('body').append($('<div />').attr('id','msgBox').append($('<div />').attr('id','msgBoxCom'))).fadeIn();
			} else {
				$('#msgBox').fadeIn()
			};
			$('#msgBoxCom').text(inf);
			$('#msgBox').delay(5000).fadeOut();			
		};

	});
})(jQuery);